## uw-spring-security

This project is intended to provide a re-usable library that integrates Spring Security with UW's common
authentication approach. 

The core of the project contains a re-usable extension of Spring's [UserDetails](http://docs.spring.io/spring-security/site/docs/3.2.6.RELEASE/apidocs/org/springframework/security/core/userdetails/UserDetails.html) called *UWUserDetails*. This interface (and implementations) provide
commonly used user attributes, like PVI, UDDS membership, full name, and email address.

### Include in your project

The following instructions assuming that you have access to the UW Releases repository in our [Maven Repository Manager](https://wiki.doit.wisc.edu/confluence/display/ST/Maven+Repository+Manager).

Add the following to your Maven pom.xml:

    <dependency>
      <groupId>edu.wisc.uwss</groupId>
      <artifactId>uw-spring-security-core</artifactId>
      <version>0.1.0</version>
    </dependency>
    <dependency>
      <groupId>edu.wisc.uwss</groupId>
      <artifactId>uw-spring-security-config</artifactId>
      <version>0.1.0</version>
    </dependency>
    
The former, -core, should be a dependency in modules that integrate the user model within your service tier. The latter, -config, depends on -core and should be a dependency of your web application.  
    
The uw-spring-security-sample-war is an example of how to activate the Spring `@Configuration` classes provided by the -config module in your application. Look at the *edu.wisc.uwss.sample.configuration* package for more detail.

## Contributing

This project is built on contributions from application developers in DoIT's community. Since we all regularly need to integrate with UW's
user data model and authentication mechanisms, 

### Developer requirements

* Java 8+
* Maven 3.2+

### Contributing

This project follows a collaboration workflow similar to what is described in the "Integration Manager" section of http://git-scm.com/book/en/Distributed-Git-Distributed-Workflows.
It can also be described using the term "Fork and Pull."

The primary repository for this project is https://bitbucket.org/uwmadison_doit/uw-spring-security. Few developers will have 'push' access to this repository; the preferred permission will be 'fetch' only.

Each developer should:

1. Fork the primary repository into their personal bitbucket account.
2. Clone the fork to their workstation.
3. Create branches for each unit of work.
4. When done, push the branch up to their personal fork.
5. Submit a pull request from the branch in their personal fork to the primary repository.

This process allows us to make use of bitbucket's excellent code review tools and gives us the flexibility to pick and choose
which features are ready for promotion at different times.

### Release Management

This module intends to adopt [Semantic Versioning](http://semver.org). Releases will be published with the Maven release plugin.