/**
 * 
 */
package edu.wisc.uwss.sample.configuration;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;

/**
 * This {@link Configuration} class provides an example of how one would amend the {@link HttpSecurity}
 * initialized in the various configuration classes in uw-spring-security-config.
 * 
 * @author Nicholas Blair
 */
@Configuration
public class SampleWebSecurityConfiguration {

  /**
   * This example puts a constraint on the "/profile" URL, requiring visitors be authenticated.
   * 
   * @param http the {@link HttpSecurity} instance made available via other {@link Configuration} classes in the -config module
   * @throws Exception see {@link HttpSecurity#authorizeRequests()}
   */
  @Autowired
  public void configure(HttpSecurity http) throws Exception {
    http.authorizeRequests().antMatchers("/profile").authenticated();
  }

}
