/**
 * 
 */
package edu.wisc.uwss.sample.web;

import org.springframework.http.MediaType;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import edu.wisc.uwss.UWUserDetails;

/**
 * Simple Web MVC {@link Controller}.
 * 
 * @author Nicholas Blair
 */
@Controller
public class SampleController {

  /**
   * @return the home view
   */
  @RequestMapping(value="/", method=RequestMethod.GET)
  public String home() {
      return "redirect:/index.html";
  }
  /**
   * 
   * @return the current {@link UWUserDetails} 
   */
  @RequestMapping(value="/profile", produces=MediaType.APPLICATION_JSON_VALUE)
  public @ResponseBody UWUserDetails whoami() {
    Object principal = SecurityContextHolder.getContext().getAuthentication().getPrincipal();
    return (UWUserDetails) principal;
  }
}
